#!/usr/bin/python
# -*- coding: utf-8 -*-

bl_info = {
    "name": "Get MH object coords",
    "category": "Mesh",
}

from .sync_ops import SyncOperator

import bpy
import pprint

pp = pprint.PrettyPrinter(indent=4)

class GetCoords(SyncOperator):
    def __init__(self):
        super().__init__('getObjectCoords')
        self.executeJsonCall()

    def callback(self,json_obj):

        print("Get object coords")

        obj = bpy.context.active_object
        print("Active object: " + obj.name)
        split = obj.name.split(':')
        active = split[len(split) - 1]
        active = active.lower() + ".obj"
        print("Active: " + active)
        print(type(json_obj))
        data = json_obj.data

        for item in data:
            print("item: name=%s vertex count=%d" % (str(item[0]),len(item[1])));
            if (str(item[0]).lower() == active):
                bpyobj = bpy.context.active_object
                bpycount = len(bpyobj.data.vertices)
                print("matches active object name with %d vertices" % bpycount)
                vcount = len(item[1])
                if bpycount < vcount:
                    vcount = bpycount
                for i in range(vcount):
                    bpyobj.data.vertices[i].co[0] = item[1][i][0]
                    bpyobj.data.vertices[i].co[1] = -item[1][i][2]
                    bpyobj.data.vertices[i].co[2] = item[1][i][1]
