#!/usr/bin/python
# -*- coding: utf-8 -*-

bl_info = {
    "name": "Get MH object names",
    "category": "Mesh",
}

from .sync_ops import SyncOperator

import bpy
import pprint

pp = pprint.PrettyPrinter(indent=4)

class GetNames(SyncOperator):
    def __init__(self):
        super().__init__('getObjectNames')
        self.executeJsonCall()

    def callback(self,json_obj):

        print("Get object names")

        obj = bpy.context.active_object
        print("Active object: " + obj.name)
        split = obj.name.split(':')
        active = split[len(split) - 1]
        print(type(json_obj))
        data = json_obj.data
        l = len(data)
        print("Length of name array in incoming data: " + str(l))  

        for i in range(len(data)):
            print("object name: " + data[i]);
            if (data[i] == active.lower() + ".obj"):
                print("matches active object name")
